import 'dart:async';

abstract class OsamRoute<A, R> {
  final A argument;
  final _completer = Completer<R>();

  OsamRoute({this.argument});

  @override
  bool operator ==(other) {
    return runtimeType == other.runtimeType;
  }

  @override
  int get hashCode => runtimeType.hashCode;

  R get result;

  set result(R result);

  void complete() => _completer.complete(result);

  Future<R> get whenComplete => _completer.future;
}
